local _, AddonTable = ...
local ExPack = ExPack;

local L = LibStub("AceLocale-3.0"):GetLocale("ExPack");
local LII = LibStub("LibItemInfo-1.0");

--https://wowpedia.fandom.com/wiki/API_GetContainerNumSlots
--local GetContainerNumSlots = C_Container.GetContainerNumSlots;
  local function getNumSlots(bagID)
    if C_Container and C_Container.GetContainerNumSlots then
      return C_Container.GetContainerNumSlots(bagID)
    else
      return GetContainerNumSlots(bagID)
    end
  end 
  
--https://wowpedia.fandom.com/wiki/API_GetContainerItemLink
--local GetContainerItemLink = C_Container.GetContainerItemLink;
  local function getItemLink(containerIndex, slotIndex)
    if C_Container and C_Container.GetContainerItemLink then
      return C_Container.GetContainerItemLink(containerIndex, slotIndex)
    else
      return GetContainerItemLink(containerIndex, slotIndex)
    end
  end 
  
  --https://wowpedia.fandom.com/wiki/API_GetContainerItemInfo
  local function getContainerItemInfo(bagID, slot)
    if C_Container and C_Container.GetContainerItemInfo then
		return C_Container.GetContainerItemInfo(bagID, slot)
	elseif GetContainerItemInfo then
	  return GetContainerItemInfo(bagID, slot)
	else
	  return icon, itemCount, locked, quality, readable, lootable, itemLink, isFiltered, noValue, itemID, isBound 
	end
  end

  --https://wowpedia.fandom.com/wiki/API_GetContainerNumFreeSlots
  local function getContainerNumFreeSlots(bagIndex)
    if C_Container and C_Container.GetContainerNumFreeSlots then
	  return C_Container.GetContainerNumFreeSlots(bagIndex)
	elseif GetContainerNumFreeSlots then
	  return GetContainerNumFreeSlots(bagIndex)
	else
	  return numFreeSlots, bagFamily 
	end
  end
  
  --https://wowpedia.fandom.com/wiki/API_GetContainerItemCooldown
  local function getContainerItemCooldown(bagID, slot)
	if C_Container and C_Container.GetContainerItemCooldown then
	  return C_Container.GetContainerItemCooldown(bagID, slot)
	elseif GetContainerItemCooldown then
	  return GetContainerItemCooldown(bagID, slot)
	else
	  return startTime, duration, isEnabled 
	end
  end
  
  function IsConsumable(classID, subclassID)
	if (classID == 15) then -- Miscellaneous
		return (subclassID == 1) -- Reagent
	else
		return (classID == 0) -- Consumable
	end
  end
  function IsArmory(classID, subclassID)
	if (classID == 2) then -- Weapon
		return true
	elseif (classID == 4) then -- Armor
		return true
	else
		return false
	end
  end
  function IsTradegoods(classID, subclassID)
	return (classID == 7) -- Tradegoods
  end
  function IsQuestitem(classID, subclassID)
	return (classID == 12) -- QuestItem
  end
  function IsJunk(classID, subclassID)
	if (classID == 15) then -- Miscellaneous
		return (subclassID == 0) -- Junk
	else
		return false
	end 
  end
  
  function BoolToStr(v)
	if v then
		return "true"
	else	
		return "false"
	end
  end
  
  function IsCurrentExPack(expacID)
	-- https://wowpedia.fandom.com/wiki/API_GetNumExpansions
	local expansionLevel = GetMaximumExpansionLevel()+1
	return (expacID ~= 0) and (expacID == expansionLevel);
  end
  
  function IsOldExPack(expacID)
	-- https://wowpedia.fandom.com/wiki/API_GetMaximumExpansionLevel
	local expansionLevel = GetMaximumExpansionLevel()+1
	return (expacID ~= 0) and (expacID ~= expansionLevel);
  end
  
  function ExPack:IsFilterSelected(classID, subclassID)
	--ExPack:dPrint("IsFilterSelected; "..classID.."; "..subclassID)
	return (self.db.profile.filters.ShowConsumable and IsConsumable(classID, subclassID))
		or (self.db.profile.filters.ShowTradegoods and IsTradegoods(classID, subclassID))
		or (self.db.profile.filters.ShowJunk and IsJunk(classID, subclassID))
		or (self.db.profile.filters.ShowQuestitem and IsQuestitem(classID, subclassID))
		or (self.db.profile.filters.ShowArmory and IsArmory(classID, subclassID));
  end
    
--[[
LoadAddOn("Blizzard_DebugTools")
ddump=DevTools_Dump
]]--
local guildBank = ExPack.guildBank;
local bag_time = 0;
local bagupdatesw = false;
local itemlockchangedsw = false;

local pickupBegin = {};
pickupBegin.pickup = false;
pickupBegin.dropped = true;

local useCombinedBags = false

--https://wowpedia.fandom.com/wiki/BagID
--Enum.BagIndex.Backpack
ExPack.Types = {
	BAGS		= 1,		-- All bags, 0 to 11, and keyring ( id -2 )
    BANK		= 2,		-- 28 main slots
	GUILDBANK	= 3,		-- 98 main slots
	REAGENTS	= 4,		-- 98 main slots
	COMBINEDBAGS= 5,		-- OneBigBags
}

ExPack.Colors = {
	CLASSIC		= "|cFFE6CC80",
	TBC			= "|cFF1EFF00",
	WOTLK		= "|cFF66ccff",
	CATA		= "|cFFff3300",
	MOP			= "|cFF00FF96",
	WOD			= "|cFFff8C1A",
	LEGION		= "|cFFA335EE",
	BFA 		= "|cFFFF7D0A",
	SHADOWLANDS = "|cFFC0C0C0",
	DRAGONFLIGHT= "|cFFFFCC00",

	yellow 		= "|cFFFFFF00",
	white 		= "|cFFFFFFFF",

	common 		= "|cFFFFFFFF",
	uncommon 	= "|cFF1EFF00",
	rare 		= "|cFF0070DD",
	epic 		= "|cFFA335EE",
	legendary 	= "|cFFFF8000",
	artifact 	= "|cFFE6CC80",
	wowtoken	= "|cFF00CCFF",

	DeathKnight = "|cFFC41F3B",
	DemonHunter = "|cFFA330C9",
	Druid 		= "|cFFFF7D0A",
	Hunter 		= "|cFFABD473",
	Mage 		= "|cFF69CCF0",
	Monk 		= "|cFF00FF96",
	Paladin 	= "|cFFF58CBA",
	Priest 		= "|cFFFFFFFF",
	Rogue 		= "|cFFFFF569",
	Shaman 		= "|cFF0070DE",
	Warlock 	= "|cFF9482C9",
	Warrior 	= "|cFFC79C6E",
};

ContainerTypes = {
	[ExPack.Types.COMBINEDBAGS] = {
		GetType = function(self)
				return ExPack.Types.COMBINEDBAGS
			end,
		GetSize = function(self, bagID)
				return getNumSlots(bagID)
			end,
		GetFreeSlots = function(self, bagID)
				-- https://wowpedia.fandom.com/wiki/API_GetContainerNumFreeSlots
				local freeSlots, bagType = getContainerNumFreeSlots(bagID)
				-- https://wowpedia.fandom.com/wiki/ItemFamily
				return freeSlots, bagType
			end,
		GetLink = function(self, slotID, bagID)
				-- https://wowpedia.fandom.com/wiki/API_GetContainerItemLink
				return getItemLink(bagID, slotID)
			end,
		GetFrame = function(self, slotID, bagID)
				--return _G["ContainerFrame"..bagID.."Item"..slotID]
				local frameIndex = (getNumSlots(bagID) + 1) - slotID;
				if (container == 0 and not IsAccountSecured()) then
					frameIndex = frameIndex + 4;
				end
				frame = _G["ContainerFrame"..(bagID+1).."Item"..frameIndex]
			end,
		GetCount = function(self, slotID, bagID)
				local _, count = getContainerItemInfo(bagID, slotID)
				return count
			end,
		GetCooldown = function(self, slotID, bagID)
				local startTime, duration, isEnabled = getContainerItemCooldown(bagID, slotID)
				return startTime, duration, isEnabled
			end,
	},
	[ExPack.Types.BAGS] = {
		GetType = function(self)
				return ExPack.Types.BAGS
			end,
		GetSize = function(self, bagID)
				return getNumSlots(bagID)
			end,
		GetFreeSlots = function(self, bagID)
				-- https://wowpedia.fandom.com/wiki/API_GetContainerNumFreeSlots
				local freeSlots, bagType = getContainerNumFreeSlots(bagID)
				-- https://wowpedia.fandom.com/wiki/ItemFamily
				return freeSlots, bagType
			end,
		GetLink = function(self, slotID, bagID)
				-- https://wowpedia.fandom.com/wiki/API_GetContainerItemLink
				return getItemLink(bagID, slotID)
			end,
		GetFrame = function(self, slotID, bagID)
				--return _G["ContainerFrame"..bagID.."Item"..slotID]
				local frameIndex = (getNumSlots(bagID) + 1) - slotID;
				if (container == 0 and not IsAccountSecured()) then
					frameIndex = frameIndex + 4;
				end
				frame = _G["ContainerFrame"..(bagID+1).."Item"..frameIndex]
			end,
		GetCount = function(self, slotID, bagID)
				local _, count = getContainerItemInfo(bagID, slotID)
				return count
			end,
		GetCooldown = function(self, slotID, bagID)
				local startTime, duration, isEnabled = getContainerItemCooldown(bagID, slotID)
				return startTime, duration, isEnabled
			end,
	},
	[ExPack.Types.BANK] = {
		GetType = function(self)
				return ExPack.Types.BANK
			end,
		GetSize = function(self)
				return NUM_BANKGENERIC_SLOTS or 28		-- hardcoded in case the constant is not set
			end,
		GetFreeSlots = function(self)
				local freeSlots, bagType = getContainerNumFreeSlots(-1)		-- -1 = player bank
				return freeSlots, bagType
			end,
		GetLink = function(self, slotID)				
				return getItemLink(-1, slotID)
			end,
		GetFrame = function(self, slotID, bagID)
				if (slotID and bagID) then
					--ExPack:dPrint("GetFrame; "..bagID.."; "..slotID)
				end
				return _G["ContainerFrame"..bagID.."Item"..slotID]
			end,
		GetCount = function(self, slotID)				
				return select(2, getContainerItemInfo(BANK_CONTAINER, slotID))
			end,
		GetCooldown = function(self, slotID)
				local startTime, duration, isEnabled = GetInventoryItemCooldown("player", slotID)
				return startTime, duration, isEnabled
			end,
	},
	[ExPack.Types.GUILDBANK] = {
		GetType = function(self)
				return ExPack.Types.GUILDBANK
			end,
		GetSize = function(self)
				return MAX_GUILDBANK_SLOTS_PER_TAB or 98		-- hardcoded in case the constant is not set
			end,
		GetFreeSlots = function(self)
				return nil, nil
			end,
		GetLink = function(self, slotID, tabID)
				if (slotID and bagID) then
					--ExPack:dPrint("GuildBank; GetLink; "..slotID.."; "..tabID)
				end
				return GetGuildBankItemLink(tabID, slotID)
			end,
		GetFrame = function(self, slotID, bagID)
				local NumSlotsPerGuildBankGroup = 14; --NUM_SLOTS_PER_GUILDBANK_GROUP
				local index = mod(slotID, NumSlotsPerGuildBankGroup);
				if ( index == 0 ) then
					index = NumSlotsPerGuildBankGroup;
				end
				local column = ceil((slotID-0.5) / NumSlotsPerGuildBankGroup);
			    local button = _G["GuildBankColumn"..column.."Button"..index];
				if button == nil then
					-- 9.x.x
					button = GuildBankframe.Columns[column].Buttons[index];
				end
				return button;
			end,
		GetCount = function(self, slotID, tabID)
				local _, count = getContainerItemInfo(tabID, slotID)
				return count
			end,
		GetCooldown = function(self, slotID)
				return nil
			end,
	},
	[ExPack.Types.REAGENTS] = {
		GetType = function(self)
				return ExPack.Types.REAGENTS
			end,
		GetSize = function(self)
				return MAX_GUILDBANK_SLOTS_PER_TAB or 98		-- hardcoded in case the constant is not set
			end,
		GetFreeSlots = function(self)
				local freeSlots, bagType = getContainerNumFreeSlots(REAGENTBANK_CONTAINER)
				return freeSlots, bagType
			end,
		GetLink = function(self, slotID, bagID)
				return getItemLink(bagID, slotID)
			end,
		GetFrame = function(self, slotID, bagID)
				return _G["ReagentBankFrameItem"..(slotID)];
			end,
		GetCount = function(self, slotID, bagID)
				local _, count = getContainerItemInfo(REAGENTBANK_CONTAINER, slotID)
				return count
			end,
		GetCooldown = function(self, slotID)
				return nil
			end,
	},
}

--- *** clean functions ***

function CleanBagSlot(BagID, slotID)
	local thisContainer = ContainerTypes[ExPack.Types.BAGS]
	local bagItemButton = thisContainer:GetFrame(slotID, bagID)
	
	CleanBagFrame(BagID, slotID, bagItemButton)
end

function CleanBagFrame(BagID, slotID, bagframe)
	if bagframe then
		if bagframe:GetParent() and bagframe:GetParent():GetID() then
			if bagframe.ExPack then
				bagframe.ExPack:SetTextColor(1,1,1) -- white
				bagframe.ExPack:SetText( "" )
				bagframe.ExPack:Hide()
			end
			if bagframe.ExPackIcon then
				bagframe.ExPackIcon:Hide()
			end
		end
		ExPack:dReset();
	end
end

function ExPack:ScanBagFrame(BagID, slotID, bagframe, thisContainer)
	if bagframe then
		if bagframe:GetParent() and bagframe:GetParent():GetID() then
			local containerID ;
			if ContainerFrameSettingsManager:IsUsingCombinedBags() then
				containerID = BagID;
			else
				containerID = bagframe:GetParent():GetID();
			end
			local slot = bagframe:GetID()
			-- first clean
			CleanBagFrame(BagID, slotID, bagframe)
			-- workarround; skip a bank-bag not filled/updated
			if (containerID) and (containerID == 100) then
				--ExPack:jPrint("ScanBagFrame; contanierID; "..containerID);
				return
			end
			local bagFrameName = bagframe:GetName()
			if (bagFrameName == nil) then
				bankCol = slot;
				bankIdx = containerID or 0;
				bagFrameName = "GuildBankItemButtonC" .. bankCol .. "B" .. bankIdx
				--ExPack:jPrint("ScanBagFrame; bagFrameName; "..bagFrameName);
			end
			local ExPackIconFrame = _G[bagFrameName .. "ExPack"]
			if self.db.profile.filters.ShowBanks then 
				local bagType = ExPack.Types.BAGS
				if thisContainer then
					bagType = thisContainer.GetType() or 0
				end
				-- skip inventory bags
				ExPack:dPrint("ScanBagFrame; "..BagID.."; "..slotID.."; "..containerID.."; "..bagType)
				if ExPack.Types.BAGS == bagType then
					if ((BagID >=0) and (BagID <= NUM_BAG_SLOTS+1)) 
						--or (containerID >= 0) and (containerID <= NUM_BAG_SLOTS+1) 
						then
						-- skip inventory bags
						ExPack:dPrint("ScanBagFrame; skipped; "..BagID.."; "..slotID.."; "..containerID.."; "..bagType)
						return
					end
				end
			end
			if not bagframe.ExPack and self.db.profile.visual.ShowCaption then
				-- REJ:GameFontNormalSmall
				-- ORG:NumberFontNormalSmall
				bagframe.ExPack = bagframe:CreateFontString(nil, "OVERLAY", "NumberFontNormalSmall")
				bagframe.ExPack:SetPoint("TOPLEFT", bagframe, 0, -2)	-- ok-DF
				bagframe.ExPack:SetTextColor(1,1,0) -- yellow
				bagframe.ExPack:SetText("")
				if self.db.profile.reports.DebugTracing then
					bagframe.ExPack:SetTextColor(1,1,1) -- white
					--ExPack:jPrint("ScanBagFrame; "..BagID.."; "..slotID);
					expname = containerID..","..slotID
					bagframe.ExPack:SetText( expname )
				end	
			end
			if not ExPackIconFrame and self.db.profile.visual.ShowBorder then
			    ExPackIconFrame = CreateFrame("Frame", bagFrameName .. "ExPack", bagframe)
				ExPackIconFrame:ClearAllPoints()
				ExPackIconFrame:SetWidth(16)
				ExPackIconFrame:SetHeight(16)
				ExPackIconFrame:SetPoint("BOTTOMLEFT", bagframe, "BOTTOMLEFT", -6, -6)
			    ExPackIconFrame.icon = ExPackIconFrame:CreateTexture()
				if false then
					ExPackIconFrame.icon:SetTexture("Interface\\Addons\\Ghordian_ExPack\\images\\ExPack3bIconBorder");
				else
					ExPackIconFrame.icon:SetTexture("Interface/Addons/Ghordian_ExPack/images/GoldenCrown.tga");
				end
				ExPackIconFrame.icon:SetAllPoints(ExPackIconFrame)
				ExPackIconFrame.icon:SetBlendMode("BLEND")
				ExPackIconFrame.icon:SetPoint("CENTER", ExPackIconFrame)
				bagframe.ExPackIcon = ExPackIconFrame;
			end

			if ( BagID and containerID and (BagID ~= containerID) ) then
				ExPack:jPrint("ScanBagFrame; BagID; containerID; "..BagID.." <> "..containerID);
			end
			if ( slotID ~= slot ) then
				ExPack:jPrint("ScanBagFrame; slotID; slot; "..slotID.." <> "..slot);
			end

			local itemLink = nil
			if thisContainer then
				if (containerID) then
					if (containerID ~= BagID) then
						--ExPack:jPrint("thisContainer; containerID; "..BagID.." <> "..containerID.."; slotID; "..slotID.." <> "..slot)
--[[
	guildBank.isGuildBankOpen = true
	guildBank.tab = GetCurrentGuildBankTab()
]]--
						if guildBank.isGuildBankOpen then
							containerID	= BagID -- needed
						end
					else
						--ExPack:jPrint("thisContainer; containerID; "..BagID.." = "..containerID.."; slotID; "..slotID.." <> "..slot)
					end
				else
					--ExPack:jPrint("thisContainer; non-containerID; "..BagID.."; slotID; "..slotID.." <> "..slot)					
					containerID	= BagID -- debug
				end
			----itemLink = thisContainer:GetLink(slot, BagID)
				itemLink = thisContainer:GetLink(slot, containerID)
			else
				if (containerID) then
					if (containerID ~= BagID) then
						--ExPack:jPrint("non-thisContainer; containerID; "..BagID.." <> "..containerID.."; slotID; "..slotID.." <> "..slot)
						--CombinedBags !
						containerID = BagID
					else
						--ExPack:jPrint("non-thisContainer; containerID; "..BagID.." = "..containerID.."; slotID; "..slotID.." <> "..slot)
					end
				else
					--ExPack:jPrint("non-thisContainer; non-containerID; "..BagID.."; slotID; "..slotID.." <> "..slot)
					containerID = BagID -- debug!
					--slot = slotID --debug
				end
				itemLink = getItemLink(containerID, slot)
			end
			if itemLink then
				-- https://wowpedia.fandom.com/wiki/API_GetItemInfo
				-- itemName, itemLink, itemQuality, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, itemTexture, sellPrice, classID, subclassID, bindType, expacID, setID, isCraftingReagent = GetItemInfo(item) 
				--       1, 2,       3,         4, 5,        6,           7,  8, 9,10,        11,      12, 		   13, 14,      15, 16,                17
				local name, _, quality, itemLevel, _, itemType, itemSubType, _, _,  _, sellPrice, classID, subclassID,  _, expacID,  _, isCraftingReagent = GetItemInfo(itemLink)
				-- mfm
				local expname = "n/a";
				local clr = "|cFFffff00";
				--local itemExpac
				local itemID = ExPack:GetIDFromLink(itemLink);
				--(expacID ~= nil) and 
				if (expacID) and (expacID > 0) then
					-- expacID
					expacID = expacID + 1;
					local itemExpac = ExPack:getMajorFromExpacID(expacID);
					if itemExpac ~= nil then
						expname = itemExpac.shortName;
						clr = itemExpac.color;
					else
						-- seguir buscando
						expacID = 0;
					end
					--ExPack:dPrint("GetItemInfo; "..expacID.." ; "..expname)
				else
					expacID = 0;
					quality = quality or -1;
					--ExPack:dPrint("No expacID; itemID; "..itemID.." ; quality; "..quality)
				end
				
				if (itemID > 0) and (expacID == 0) then
					local itemVersion, itemExpac = ExPack:myGetVersion(itemID);
					if itemVersion then
						--ExPack:vardump (itemVersion);
						itemExpac = ExPack:myGetVersionExpac(itemVersion);
						-- if itemExpac ~= nil then
							-- expname = itemExpac.shortName;
							-- clr = itemExpac.color;
							-- expacID = itemVersion.major;
						-- else
							-- ExPack:dPrint("itemExpac nil; "..itemID.." ; "..quality)
							-- if not self.db.profile.advanced.UseItemVersion then
								-- don't show "n/a"
								-- expname = "";
							-- end
						-- end
					end
					
					if itemExpac then
						if itemExpac ~= nil then
							expname = itemExpac.shortName;
							clr = itemExpac.color;
							expacID = itemExpac.expansionID;
						else
							ExPack:dPrint("itemExpac nil; "..itemID.." ; "..quality)
							if not self.db.profile.advanced.UseItemVersion then
								-- don't show "n/a"
								expname = "";
							end
						end					
					else
						ExPack:dPrint("itemVersion nil; "..itemID.." ; "..quality)
						if not self.db.profile.advanced.UseItemVersion then
							-- don't show "n/a"
							expname = "";
						end
					end
				end
--
				local ShowExPack = ( (self.db.profile.filters.ShowAll 
					 or (self.db.profile.filters.ShowReagents and (isCraftingReagent or false)))
					or ExPack:IsFilterSelected(classID, subclassID) )
					and (self.db.profile.filters.AnyExpansion
					 or (self.db.profile.filters.CurrentExpack and IsCurrentExPack(expacID))
					 or (self.db.profile.filters.OldExpacks and IsOldExPack(expacID)) );
				local Color = {}
				local r,g,b
				r, g, b = clr:match("|cFF(%x%x)(%x%x)(%x%x)")
				r, g, b = tonumber(r, 16), tonumber(g, 16), tonumber(b, 16)
				Color.r, Color.g, Color.b = r / 255, g / 255, b / 255						
				if bagframe.ExPack then					
					if self.db.profile.general.Enabled then
						if (itemID > 0) and ShowExPack and self.db.profile.visual.ShowCaption then
							-- Apply appearance config:
							bagframe.ExPack:ClearAllPoints()
							bagframe.ExPack:SetPoint(self.db.profile.visual.Position, unpack(ExPack.PositionOffsets[self.db.profile.visual.Position]))
							bagframe.ExPack:SetFontObject(ExPack.Fonts[self.db.profile.visual.Font] or NumberFontNormal)
							
							bagframe.ExPack:SetTextColor(Color.r, Color.g, Color.b);
							bagframe.ExPack:SetText( expname );
							bagframe.ExPack:Show();
						else
							bagframe.ExPack:SetText( "" )
						end
					else
						bagframe.ExPack:SetText( "" )
					end
				end				
				if ExPackIconFrame then
					if self.db.profile.general.Enabled then
						if (itemID > 0) and ShowExPack and self.db.profile.visual.ShowBorder then
							ExPackIconFrame.icon:SetVertexColor(Color.r, Color.g, Color.b, 1)
							ExPackIconFrame:Show();
						else
							ExPackIconFrame:Hide();
						end
					else
						ExPackIconFrame:Hide();
					end;
				end
			else
				if bagframe.ExPack then
					expname = ""
					bagframe.ExPack:SetTextColor(1,1,1) -- white
					if self.db.profile.reports.DebugTracing 
						--and self.db.profile.filters.ShowAll 
						then
					  expname = containerID..","..slot
					end
					bagframe.ExPack:SetText( expname )
				end
				if ExPackIconFrame then
					ExPackIconFrame:Hide();
				end
			end
		else
			if bagframe.ExPack then
				bagframe.ExPack:SetTextColor(1,1,1) -- white
				bagframe.ExPack:SetText( "" )
			end
			if ExPackIconFrame then
				ExPackIconFrame:Hide();
			end
		end
	else
		--ExPack:jPrint("No bagframe; "..BagID..";"..slotID)
		--ExPack:dPrint("No bagframe; "..BagID..";"..slotID)
	end
end

local printcount = 0

function ExPack:vardump (t)
	ExPack:dReset();
	if (type (t) ~= "table") then
		return
	end
	if ( printcount > 0 ) then
		for a,b in pairs (t) do 
			ExPack:dPrint (a,b)
		end
		printcount = printcount -1
	end
end

function ExPack:dPrint(...)
	if self.db.profile.reports.DebugTracing then
		ExPack:Print(...)
	end
end

function ExPack:jPrint(...)
	if ( printcount > 0 ) then
		ExPack:dPrint(...)
		printcount = printcount -1
	end
end

function ExPack:dReset(...)
	printcount = 15
end

-- *** ItemVersion Data API ***

function ExPack:GetIDFromLink(link)
	if link then
		local id = link:match("item:(%d+):");
		if id then 
			return tonumber(id); 
		elseif link:find("\124Hbattlepet:") then -- caged battle pets all share a single itemid
			return 82800;
		else 
			return 0; 
		end;
	else
		return -1; 
	end;
end

function ExPack:myGetVersion(itemId)
	-- caller must ensure that itemId is a number (188655;169701)
	local itemVersion = nil;
	local itemExpac = nil;

	-- 1st priority using the new library, only works for reagents or so :(
	if self.db.profile.advanced.UseLibItemInfo then 	
		--ExPack:dPrint("ExPack:myGetVersion; UseLibItemInfo; "..itemId)
		-- try to find expacID using LibItemInfo
		local itemType, expansion, expansionID, arg1, arg2, arg3 = LII:GetItemSource(itemId)
		if itemType and expansion then
			expansionID = expansionID + 1;
			--ExPack:dPrint("ExPack:myGetVersion; expansionID; "..expansionID)
			itemExpac = ExPack:getMajorFromExpacID(expansionID);
			itemExpac.expansionID = expansionID
			--ExPack:vardump(itemExpac);
		else
			ExPack:dPrint("LII:GetItemSource; no expansionID; ")
			itemExpac = nil;
		end
	else
		ExPack:dPrint("ExPack:myGetVersion; do not use UseLibItemInfo; ")
	end
	
	--if (itemVersion == nil) then
	if (itemExpac == nil) then
		if self.db.profile.advanced.UseItemVersion then
			--ExPack:dPrint("ExPack:myGetVersion; itemIdToVersionId; "..itemId)
			local versionId = ExPack.itemIdToVersionId[itemId];
			if (versionId == nil) then
				--ExPack:dPrint("ExPack:myGetVersion; not direct found itemId; "..itemId)
				versionId = ExPack:getItemVersion(itemId);
			end
			-- item id found in current database
			if versionId then
				--ExPack:dPrint("ExPack:myGetVersion; direct found versionId; "..versionId)
				itemVersion = ExPack.versionIdToVersion[versionId];
				--ExPack:vardump(itemVersion);
			else
				ExPack:dPrint("ExPack:myGetVersion; versionId nil; "..itemId)
			end
		else
			ExPack:dPrint("ExPack:myGetVersion; do not use UseItemVersion; ")
		end
	end
	
	return itemVersion, itemExpac;
end

function ExPack:GuildBankFrame_RemoveExPack()
	--ExPack:dPrint("GuildBankFrame_RemoveExPack")
	local thisContainer = ContainerTypes[ExPack.Types.GUILDBANK];
	local size = thisContainer:GetSize();
	local tab = GetCurrentGuildBankTab();
	local group = 14; --NUM_SLOTS_PER_GUILDBANK_GROUP;
	local index, column, button;
	for i=1, size do
		index = mod(i, group);
		if ( index == 0 ) then
			index = group;
		end
		column = ceil((i-0.5) / group);
		button = _G["GuildBankColumn"..column.."Button"..index];
		if (button == nil) then
			--ExPack:dPrint("GuildBankColumn fail")
			if (GuildBankFrame) then
				button = GuildBankFrame.Columns[column].Buttons[index];
			else
				-- bagnon or other bag addon
			end
		end
		if button then
			CleanBagFrame(tab, i, button);
		end
	end
end

function ExPack:BankFrame_RemoveExPack()
	ExPack:dPrint("BankFrame_RemoveExPack")
	local thisContainer = ContainerTypes[ExPack.Types.BANK]
	local bagID = BANK_CONTAINER
	local size = thisContainer:GetSize(bagID)
	for slotID=1, size, 1 do
		button = thisContainer:GetFrame(slotID, bagID)
		if button then
			CleanBagFrame(bagID, slotID, button)
		end
	end
end

---

function ExPack:ScanContainer(BagID, containerType)
	if not self.db.profile.general.Enabled then return end

	if self.db.profile.filters.ShowBanks then 
		if (containerType == ExPack.Types.BAGS) then
			if (BagID <= NUM_BAG_SLOTS+1) then
				-- skip inventory bags
				--ExPack:jPrint("ScanContainer; Skip; "..containerType.."; "..BagID)
				return
			end
		end
	end
	if (BagID) then
		ExPack:dPrint("ScanContainer; "..containerType.."; "..BagID)
	end

	local thisContainer = ContainerTypes[containerType]
	
	local bag = {}
	bag.size = thisContainer:GetSize(BagID)
	bag.freeslots, bag.bagtype = thisContainer:GetFreeSlots(BagID)
	bag.container = 0; --isOpen = 0;
	if IsBagOpen(BagID) then
		bag.container = (BagID+1);
	end;

	if (BagID) then
		--ExPack:dPrint("ScanContainer; "..containerType.."; "..BagID.."; bag; "..bag.size.."; "..bag.freeslots.."; "..bag.container)
		--ExPack:dPrint("ScanContainer; ".."bag; "..bag.size.."; "..bag.freeslots.."; "..bag.container)
		ExPack:dReset()
	end
	
	for slotID=1,bag.size do
		-- TutorialHelper:GetItemContainerFrame
		-- ContainerIDToInventoryID ?
		local frame = nil
		if (containerType == ExPack.Types.BAGS) then
			local frameIndex = (getNumSlots(BagID) + 1) - slotID;
			if (container == 0 and not IsAccountSecured()) then
				frameIndex = frameIndex + 4;
			end
			frame = _G["ContainerFrame"..bag.container.."Item"..frameIndex]
		--  frame = thisContainer:GetFrame(BagID, slotID)
		else
			frame = thisContainer:GetFrame(slotID, BagID)
		end
		ExPack:ScanBagFrame(BagID, slotID, frame, thisContainer)
	end
end

function ExPack:ScanBag(bagID)
	if not self.db.profile.general.Enabled then return end
	if (bagID < 0) then return end

	--ExPack:dPrint("ScanBag; basic; "..bagID)
	ExPack:dReset()

	ExPack:ScanContainer(bagID, ExPack.Types.BAGS)
end

function ExPack:ExPack_ScanBag(bagID)
	if not self.db.profile.general.Enabled then return end
	--
	ExPack:dPrint("ExPack_ScanBag; "..bagID)

	ExPack:ScanBag(bagID)
end

function ExPack:ExPack_ScanBags(event)
	if not self.db.profile.general.Enabled then return end
	--
	local msg = "ExPack_ScanBags"
	if event then
		msg = msg.."; "..event
	end
	ExPack:dPrint(msg)
	if ( GetTime() - bag_time > 0.5 ) then
		if not bagupdatesw then
			bagupdatesw = true;
			ExPack:RegisterEvent("BAG_UPDATE")
		end
		local thisContainer = ContainerTypes[ExPack.Types.BAGS]
		-- https://wowpedia.fandom.com/wiki/BagID
		local size = NUM_CONTAINER_FRAMES or 5
		for bagID=0,size do
			--ExPack:jPrint("ExPack_ScanBags; "..bagID)
			ExPack:ScanBag(bagID, thisContainer)
		end
	end
	bag_time = GetTime()
end

--[[
function ExPack:ExPack_OpenAllBags(...)
	if not self.db.profile.general.Enabled then return end
	-- https://wowpedia.fandom.com/wiki/API_OpenAllBags
	ExPack:ExPack_ScanBags("OpenAllBags")
end

function ExPack:ExPack_ToggleAllBags(...)
	if not self.db.profile.general.Enabled then return end
	--
	ExPack:ExPack_ScanBags("ToggleAllBags")
end

function ExPack:ExPack_ToggleBag(bagNum)
	if not self.db.profile.general.Enabled then return end
	-- https://wowpedia.fandom.com/wiki/API_ToggleBag
	ExPack:ExPack_ScanBag(bagNum)
end

function ExPack:ExPack_OpenBag(id)
	if not self.db.profile.general.Enabled then return end
	-- https://wowpedia.fandom.com/wiki/API_OpenBag
	ExPack:ExPack_ScanBag(id)
end
]]--

function ExPack:CleanPickupItem()
	ExPack:dPrint("CleanPickupItem; ")
	if (not pickupBegin.dropped) then
		pickupBegin.dropped = true
		ExPack:ScanBag(pickupBegin.bagID)
		--ExPack:ExPack_ScanBags("PickupContainerItem;"..pickupBegin.bagID.."; "..pickupBegin.slot) 
		pickupBegin.pickup = false
		pickupBegin.bagID = -1
		pickupBegin.slot = -1
	end
end

function ExPack:ExPack_PickupContainerItem(...)
	if not self.db.profile.general.Enabled then return end
	-- https://wowpedia.fandom.com/wiki/API_PickupContainerItem
	local bagID, slot = ...; 
	
	if not itemlockchangedsw then
		--itemlockchangedsw = true;
		--ExPack:RegisterEvent("ITEM_LOCK_CHANGED")
	end
	
	local hasItem = CursorHasItem()
	--ExPack:dPrint("PickupContainerItem; "..bagID.."; "..slot.."; "..BoolToStr(hasItem))
	
	if (hasItem) then
		pickupBegin.bagID = bagID
		pickupBegin.slot = slot
		if (not pickupBegin.pickup) then
			-- starting a pickup action
			pickupBegin.pickup = hasItem
			pickupBegin.dropped = false
			--ExPack:dPrint("PickupContainerItem; begin; "..bagID.."; "..slot)
		else
			--ExPack:dPrint("PickupContainerItem; drop; "..bagID.."; "..slot)
		end
		ExPack:ExPack_ScanBags("PickupContainerItem;"..bagID.."; "..slot) 
	else
		if (pickupBegin.pickup) then
			-- droping an item - ending a pickup action
			pickupBegin.pickup = false
			local freeslots, bagtype = getContainerNumFreeSlots(pickupBegin.bagID)
			--ExPack:dPrint("PickupContainerItem; end; "..pickupBegin.bagID.."; "..pickupBegin.slot.."; "..freeslots.."; "..bagtype)
			ExPack:ScanBag(pickupBegin.bagID)
		else
			-- cancelling/failled a pickup
			pickupBegin.bagID = -1
			pickupBegin.slot = -1
			pickupBegin.pickup = false
			ExPack:ExPack_ScanBags("PickupContainerItem; "..bagID.."; "..slot) 
		end	
	end
end

--	

function ExPack:ExPack_BankFrameItemButton_Update(button)
	if not self.db.profile.general.Enabled then return end
	if not button.isBag then
		if button:GetParent() and button:GetParent():GetID() then
			local buttonID = button:GetID();
			--ExPack:dPrint("BankFrameItemButton_Update; "..buttonID)

			ExPack:ExPack_ScanThisBag(button, ExPack.Types.BANK)
		end
	end
end

---

function ExPack:ExPack_BagsUpdate(event)
	if not self.db.profile.general.Enabled then return end
	ExPack:dPrint("ExPack_BagsUpdate; "..event)

	if bag_time == 0 then 
		ExPack:ExPack_ScanBags() 
	end
	if GetTime() - bag_time > 0.3 then
		ExPack:ExPack_ScanBags(event)
	end
	bag_time = GetTime()
end

function ExPack:ScanReagentBank()
	if not self.db.profile.general.Enabled then return end
	ExPack:dPrint("ScanReagentBank")
	ExPack:dReset();
	
	ExPack:ScanContainer(REAGENTBANK_CONTAINER, ExPack.Types.REAGENTS)
end

function ExPack:ExPack_ScanThisBag(button, containerType)
	if not self.db.profile.general.Enabled then return end
	if button then
		local id = button:GetID()
		--ExPack:dPrint("ExPack_ScanThisBag; "..id.."; "..containerType)

		local thisContainer = nil 
		local container = button:GetParent():GetID();
		local buttonID = button:GetID();
		local inventoryID = button:GetInventorySlot();
		if ( button.isBag ) then
		-- we dont want to see where the actually bag(s) comes from ;-)
		else
			ExPack:ScanBagFrame(container, inventoryID, button, thisContainer)
		end
	end
end

function ExPack:ExPack_BagnonFrameInventory()
	if not self.db.profile.general.Enabled then return end
	ExPack:dPrint("ExPack_BagnonFrameInventory")
end

function ExPack:getMajorFromExpacID(expacID)
	if (AddonTable ~= nil) then
		--ExPack:dPrint("ExPack:getMajorFromExpacID; AddonTable; "..expacID);
		return AddonTable.majorToExpac[expacID]
	elseif (ExPack.majorToExpac ~= nil) then
		--ExPack:dPrint("ExPack:getMajorFromExpacID; majorToExpac; "..expacID);
		return ExPack.majorToExpac[expacID]
	else
		--ExPack:dPrint("ExPack:getMajorFromExpacID; Self; "..expacID);
		return self.majorToExpac[expacID]
	end
end

function ExPack:myGetVersionExpac(itemVersion)
	if (AddonTable ~= nil) then
		--ExPack:dPrint("ExPack:myGetVersionExpac; AddonTable; "..version.major);
		return AddonTable.majorToExpac[itemVersion.major]
	elseif (ExPack.majorToExpac ~= nil) then
		--ExPack:dPrint("ExPack:myGetVersionExpac; ExPack.majorToExpac; "..version.major);
		return ExPack.majorToExpac[itemVersion.major]
	else
		--ExPack:dPrint("ExPack:myGetVersionExpac; self.majorToExpac; "..version.major);
		return self.majorToExpac[itemVersion.major]
	end
end 

function REJ_ExPack_Container_Update(container)
	local bagID = container:GetID()
	local slotID = 0
	local name = container:GetName()
	ExPack:dPrint("ExPack_Container_Update; container; "..name);
	
	local thisContainer = ContainerTypes[ExPack.Types.BAGS]
	for i = 1, container.size, 1 do
		local frame = _G[name .. "Item" .. i]
		--UpdateContainerButton(button, bag)
		ExPack:ScanBagFrame(bagID, slotID, frame, thisContainer)
	end
end

function ExPack_ContainerFrame_GenerateFrame(frame, size, id)
	ExPack_ContainerFrame_Update(frame, size, id)
end

function ExPack_ContainerFrame_Update(frame, size, id)
	local name = frame:GetName()
	ExPack:dPrint("ExPack_ContainerFrame_Update; frame;"..name.."; size;"..size.."; id;"..id);
	
	local thisContainer = nil
	local combinedbags = false;
	if ContainerFrameSettingsManager:IsUsingCombinedBags() then
		combinedbags = true
	end
	useCombinedBags = GetCVarBool("combinedBags");
	if useCombinedBags then
		if name == "ContainerFrameCombinedBags" then
			ExPack:dPrint("ExPack_ContainerFrame_Update; combinedBags;"..BoolToStr(combinedbags).."; useCombinedBags; "..BoolToStr(useCombinedBags));
			-- Inspected via /tinspect ContainerFrameCombinedBags
			thisContainer = ContainerTypes[ExPack.Types.BAGS]
		end
	else
		thisContainer = ContainerTypes[ExPack.Types.BAGS]
	end
	
    for i, bagItemButton in frame:EnumerateValidItems() do
        if (bagItemButton) then
			local bagID = bagItemButton:GetBagID();
			local slotID = bagItemButton:GetID();
			if useCombinedBags then
				ExPack:dPrint("ExPack_ContainerFrame_Update; i; "..i.."; bagID;"..bagID.."; slotID;"..slotID);
				
				local itemButton = ContainerFrameUtil_GetItemButtonAndContainer(bagID, slotID);
				local info = C_Container.GetContainerItemInfo(bagID, slotID);
			end
--[[
            local texture, itemCount, locked, quality, readable, _, itemLink, isFiltered, noValue, itemID, isBound
            if (GetContainerItemInfo) then
                texture, itemCount, locked, quality, readable, _, itemLink, isFiltered, noValue, itemID, isBound = GetContainerItemInfo(BagID, slotID);
            else
                local info = C_Container.GetContainerItemInfo(BagID, slotID)
                itemID = info and info.itemID;
            end
]]--
			ExPack:ScanBagFrame(bagID, slotID, bagItemButton, thisContainer)
        end
    end
end

--[[
-- expose API functions
ExPack.getItemVersion = AddonTable.getItemVersion
ExPack.buildVersionString = AddonTable.buildVersionString
ExPack.majorToExpac = AddonTable.majorToExpac
]]--
ExPack.getVersionExpac = AddonTable.getVersionExpac
